local frame = CreateFrame("Frame",nil,UIParent)
local L=GE[GetLocale()];
if type(L)~="table" then L=GE["enUS"]; end
local markPath=[[Interface\AddOns\Green_Elephant\Textures\green_elephant.tga]];
local TFrames={};

UnitPopupButtons["ADDTOBL"] = {text = "|cff0cff00"..L["add"].."|r"};
UnitPopupMenus["PLAYER"][#(UnitPopupMenus["PLAYER"])-1] = "ADDTOBL";

hooksecurefunc("UnitPopup_OnClick", function(self) 
          if (self.value == "ADDTOBL") then
		  local GNPFU=_G.C_NamePlate.GetNamePlateForUnit("target");
		  local GUID=UnitGUID("target"); local UN=GetUnitName("target",true);
		  AddIgnore(GetUnitName("target",true));
		  	if type(GNPFU)=="table" then 
				TFrames["GE_NPUA_"..UN] = frame:MARK(GNPFU,UIParent,"GE_NPUA_"..UN,50,50,0,25); TFrames["GE_NPUA_"..UN]:Show();
				TFrames["GE_NPUA_"..UN]:SetScript("OnClick", function(self)
					DoEmote("spit", UN);
				end)
			end
          end 
   end)

function frame:split(inputstr, sep)
        if inputstr == nil or inputstr=="" then return ""; end
		if sep == nil then sep = "%s"; end
        local t={}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                table.insert(t, str)
        end
        return t;
end

function frame:inIgnorList(name)
	local NI = C_FriendList.GetNumIgnores();
	name=frame:split(name,"-");
	if NI>0 then
		for i=1,NI do
			local GIN = frame:split(C_FriendList.GetIgnoreName(i),"-");
			if GIN[1]==name[1] then 
				return 1;
			end
		end
	end
	return 0;
end

function LFGMARK()
	if LFGListApplicationViewerScrollFrame:IsVisible() then 
	local noP="";local btn1=nil;
		for i = 1, 50 do
			local bm=_G["LFGListApplicationViewerScrollFrameButton"..i]; 
			if type(bm) == "table" and noP ~= bm["Member1"]["Name"]:GetText() then 
				
				if type(TFrames["GE_NPUAlfg_"..i]) == "table" then
				TFrames["GE_NPUAlfg_"..i]:Hide(); TFrames["GE_NPUAlfg_"..i].texture:SetTexture("");
				end
				noP=bm["Member1"]["Name"]:GetText();		
				if frame:inIgnorList(noP)>0 then
				TFrames["GE_NPUAlfg_"..i] = frame:MARK(bm,bm,"GE_NPUAlfg_"..i,20,20,0,-10); TFrames["GE_NPUAlfg_"..i]:Show();
				end 
			end
		end
	end
end

function frame:MARK(FramePoint,PARENT,name,w,h,x,y)
	local f = CreateFrame("BUTTON",name,PARENT);
	f:SetFrameStrata("BACKGROUND");f:SetSize(w,h);
	f.texture=f:CreateTexture(); f.texture:SetTexture(markPath); f.texture:SetAllPoints(f); 
	f:SetPoint("BOTTOM",FramePoint,"CENTER", x, y);
	return f;
end


function frame:NAME_PLATE_UNIT_ADDED(UToken) 
	local GNPFU=_G.C_NamePlate.GetNamePlateForUnit(UToken);
	local GUID=UnitGUID(UToken); local UN=GetUnitName(UToken,true);
	
	if type(GNPFU)=="table" and frame:inIgnorList(UN)>0 then 
		TFrames["GE_NPUA_"..UN] = frame:MARK(GNPFU,UIParent,"GE_NPUA_"..UN,50,50,0,25); TFrames["GE_NPUA_"..UN]:Show();
		TFrames["GE_NPUA_"..UN]:SetScript("OnClick", function(self)
			DoEmote("spit", UN);
		end)
	end
end

function frame:NAME_PLATE_UNIT_REMOVED(UToken)
	local GNPFU=_G.C_NamePlate.GetNamePlateForUnit(UToken);
	local GUID=UnitGUID(UToken); local UN=GetUnitName(UToken,true);
	if type(TFrames["GE_NPUA_"..UN]) == "table" then
		TFrames["GE_NPUA_"..UN]:Hide(); TFrames["GE_NPUA_"..UN].texture:SetTexture("");
	end
end

function frame:LFG_LIST_APPLICANT_UPDATED(UToken)
	   LFGMARK();
end
function frame:LFG_LIST_APPLICANT_LIST_UPDATED(UToken)
	   LFGMARK();
end

local timer = C_Timer.NewTicker(0.2, LFGMARK);

frame:RegisterEvent("LFG_LIST_APPLICANT_UPDATED");
frame:RegisterEvent("LFG_LIST_APPLICANT_LIST_UPDATED");

frame:RegisterEvent("NAME_PLATE_UNIT_ADDED");
frame:RegisterEvent("NAME_PLATE_UNIT_REMOVED");
frame:SetScript("OnEvent",function(self, event, ...) self[event](self, ...) end)
